#include <vector>
#include <iostream>

using namespace std;

class TypesetterArt {
private:
    int nRenders;
    int nFonts;
    int precision;
    int width;
    int height;
    vector<int> original;

    int letterW;
    int letterH;
    
    int fontId = 0;
    int letterId = 31;
    int fontSize = 8;
	
public:
    int init(int nRenders, int nFonts, int precision, int width, int height, vector<int> image) {
        this->nRenders = nRenders;
        this->nFonts = nFonts;
        this->precision = precision;
        this->width = width;
        this->height = height;
        this->original = image;
        
		// You can convert the image argument to 3D array as follows:
        //int index = 0;
        //for (int k = 0; k < 4; k++) {
        //    for (int i = 0; i < height; i++) {
        //        for (int j = 0; j < width; j++) {
        //            layers[k][i][j] = image[index++];
        //        }
        //    }
        //}
        
        return 0;
    }
    
    vector<int> nextGlyph(int width, int height, vector<int> bitmask, int remainingMillis) {
        if (letterId < 127) {
          letterId++;
        } else {
          letterId = 32;
          fontId++;
        }
        
        if (letterId < 127 && fontId < nFonts) {
            return vector<int> { letterId, fontId, fontSize };
        }
        else {
            return vector<int> { };
        }
    }
    
   vector<int> render(int iteration, int remainingMillis) {
        if (iteration >= 4 || fontId >= nFonts) {
            return vector<int> { };
        }
        
        return vector<int> { fontId, fontSize, iteration, 255 };
    }
};

// Do not submit the main.
int main() {
	TypesetterArt *sol = new TypesetterArt;
        
	int nRenders;
	int nFonts;
	int precision;
	int width;
	int height;
	
	cin >> nRenders >> nFonts >> precision >> width >> height;
	{    
		int n;
		
		cin >> n;
		vector<int> image(n);

		for (int i = 0; i < n; i++) {
			cin >> image[i];
		}

		cerr << "Calling init\n";

		int d = sol->init(nRenders, nFonts, precision, width, height, image);

		cerr << "Return from init: " << d;

		cout << d << "\n" << flush;
	}
	
	bool callNext = true;
	while (callNext) {
		int glyphWidth;
		int glyphHeight;
		int n;
		
		cin >> glyphWidth >> glyphHeight >> n;
		
		vector<int> bitmask(n);
		for (int i = 0; i < n; i++) {
			cin >> bitmask[i];
		}
		int remainingMillis;
		cin >> remainingMillis;
		
		cerr << "Calling next glyph\n";
		
		vector<int> ret = sol->nextGlyph(glyphWidth, glyphHeight, bitmask, remainingMillis);
		
		cerr << "Return from next glyph size: " << ret.size() << "\n";
		
		if (ret.size() == 0) {
			callNext = false;
			cout << "\n";
		}
		else {
			cout << ret[0] << " " << ret[1] << " " << ret[2] << "\n" << flush;
		}
	}
	
	for (int i = 0; i < nRenders; i++) {
		int remainingMillis;
		cin >> remainingMillis;
		
		cerr << "Calling render\n";
		
		vector<int> ret = sol->render(i, remainingMillis);
		
		cerr << "Return from render size: " << ret.size() << "\n";
		
		cout << ret.size() << "\n";
		for (int x : ret) {
			cout << x << "\n";
		}
		cout << flush;
	}
		
	delete sol;
	return 0;
}